//+------------------------------------------------------------------+
//|                                      BasketTR_CommonsInclude.mqh |
//|                                 Copyright  2009.06.04, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009.06.04, SwingMan"
#property link      ""

/*---- PROCEDURES ----------------------------------------------------
void Set_DisplayInitialisations()
void Get_MarketInfoValues()
void Show_TitlesUpper()   
void Show_TitlesLeftRanked(int iRow, int iTitle)
void Show_CurrentPriceRanked(int iRow, int iTitle)
string Get_EntryPrice(int iOrderType, string sSymbol, int iTF)
void Set_ColumnNumbers()
void Delete_TextObjects()
void SetLabelObject(string sName, string sText, color dColor, int xx, int yy)
void SetLabelObjectValues(string sName, string sText, color dColor, int xx, int yy)
void SetTimeObject(string sName, string sText, color dColor, int xx, int yy)
void SetArrowObject(string sName, int ArrowCode, int iHeight, color dColor, int xx, int yy)
void DeleteObject(string sName)
void Get_TimeFrameListValues()
void Get_PairListNames(string PairsList)
void Get_SinglePairs()
string Set_SymbolUppercase(string sText)
void SendAlerts(int iOrderType, string sSymbol, int iPeriod, string sPeriod, string sPrice, string sInitialSL, int i, int col, int iRank)
void PlayAlertSound()
string Get_sPeriod(int timeframe)
string Get_SymbolSuffix(string sSymbol)
void Write_CurrentTime(int xx, int yy)

void Get_HiloMavgTrend(string sSymbol, int iTF,
         int& iTrend, double& dMAvgHighs, double& dMAvgLows, int iBar)
void Get_HullTrend(string sSymbol, int iTF, int Hull_period,
         int& iTrend, double& HullValue, int iBar)
void Get_IndicatorValues()
                  
void Get_InitialNumberTradeSignals()
--------------------------------------------------------------------*/

//####################################################################


//####################################################################
//+------------------------------------------------------------------+
//|   Set Display Initialisations
//+------------------------------------------------------------------+
void Set_DisplayInitialisations()
{
   int i,it, is;
   int iCol = 1;
   
   //=================================================================
   //---- TimeFrame strings
   for (it=1; it<=NumberTimeFrames; it++) {
      sTimeFrame[it] = Get_sPeriod(iTimeFrame[it]);   
   }
   
   //=================================================================
   //=================================================================
   //---- column numbers
   //-- first columns
   colDB_Pairs = iCol; iCol++;
   //-- current price
   if (ShowColumn_CurrentPrice == true) {
      colDB_LastPrice = iCol; iCol++;
   }   
   //-- trade columns
   if (EATrading_Activ == true) {colTrade_Arrow = iCol; iCol++;}
      colTrade_Entry = iCol; iCol++;
      colTrade_SL    = iCol; iCol++;
   if (EATrading_Activ == true) {colTrade_Win   = iCol; iCol++;}

   //=================================================================
   //=================================================================
   if (SymbolSuffix != "") {
      int spaceSuffix  = 8;
      int spaceSuffix2 = 6;
      int spaceSuffix4 = 4;
   }
   else{
      spaceSuffix = 0;
      spaceSuffix2= 0;
      spaceSuffix4= 0;
   }   
   //-- signal column
   colDB_Signals = iCol; iCol++;
   //-- time frame columns
   iColDB_FirstTF = iCol; iCol++;

   //---- x Column Symbols
   iCol = colDB_Pairs;
   xCol[iCol]  = xLeftTitle; iCol++;

   //---- x Column Current Price
   if (ShowColumn_CurrentPrice == true) {
      xCol[iCol] = xCol[iCol-1] + spaceCurrentPrice_Column + spaceSuffix; iCol++;
   }

   //---- x Column Trading   
   if (EATrading_Activ == true) {
      if (ShowColumn_CurrentPrice == true) 
           {xCol[iCol] = xCol[iCol-1] + 55; iCol++;}                        //colTrade_Arrows
      else {xCol[iCol] = xCol[iCol-1] + spaceCurrentPrice_Column; iCol++;}  //colTrade_Arrow   
      xCol[iCol] = xCol[iCol-1] + 15; iCol++;                 //colTrade_Entry
      xCol[iCol] = xCol[iCol-1] + 50 + spaceSuffix2; iCol++;  //colTrade_SL
   }
   else
   if (EATrading_Activ == false) {
      if (ShowColumn_CurrentPrice == true) 
           {xCol[iCol] = xCol[iCol-1] + 55; iCol++;}                        //colTrade_Entry
      else {xCol[iCol] = xCol[iCol-1] + spaceCurrentPrice_Column; iCol++;}  //colTrade_Entry
      xCol[iCol] = xCol[iCol-1] + 50 + spaceSuffix2; iCol++;  //colTrade_SL
   }      

   if (EATrading_Activ == true) {xCol[iCol] = xCol[iCol-1] + 50 + spaceSuffix; iCol++;}  //colTrade_Win    
   
   //---- x Column Signals
   xCol[iCol] = xCol[iCol-1] + spaceSignal_Column; iCol++;
   
//Comment("\n\n\n",colDB_Pairs," ",colDB_LastPrice," ",colTrade_Arrow," ",colTrade_Entry," ",colTrade_SL," ",colTrade_Win," ",
//colDB_Signals," ",iColDB_FirstTF," xEntry=",xCol[colTrade_Entry]," xSL=",xCol[colTrade_SL]);

   //---- x Columns TimeFrames .......................................
   //---- first TF column
   xCol[iCol] = xCol[iCol-1] + spaceFirstTF_Column;  iCol++;   
   //---- all TF columns   
   for (it=2; it <= NumberTimeFrames; it++) {      
      if (it == 2) 
         { xCol[iCol] = xCol[iCol-1] + spaceTimeFrame_Columns + 8;  iCol++; }
      else 
         { xCol[iCol] = xCol[iCol-1] + spaceTimeFrame_Columns;  iCol++; }
   }
   int lastColumn = iCol;

   //=================================================================
   //=================================================================
   //---- Columns after time frames   
   //---- x Column ATR
   if (ShowColumn_ATR == true) {
      colDB_ATR = lastColumn; lastColumn++;
      xCol[iCol] = xCol[iCol-1] + colStepSpread; iCol++;
   }  
   //---- x Column Spread
   if (ShowColumn_PairSpread == true) {
      colDB_Spread = lastColumn; lastColumn++;
      xCol[iCol] = xCol[iCol-1] + colStepSpread; iCol++;
   }  
   
   //---- x Column CombiTrend ............................... 
   if (ShowColumn_CombiTrend == true) {   
      colCombiTFs = lastColumn; lastColumn++;
      xCol[colCombiTFs] = xCol[iCol-1] + colStepD1Trend + spaceSuffix4; iCol++;
   } else {
      colCombiTFs = lastColumn; lastColumn++;
   }
   
   //---- x Column MainTrend ...............................
   if (ShowColumn_MainTrend == true) {   
      colUpperTFs = lastColumn; lastColumn++;
      xCol[colUpperTFs] = xCol[iCol-1] + colStepD1Trend+10; iCol++;
   } else {
      colUpperTFs = lastColumn; lastColumn++;
   } 

   //=================================================================
   //=================================================================
   //---- y Rows
   yRow[0] = yTitle2;// + rowStep;
   for (is=1; is<=NumberSymbols; is++)
      yRow[is] = yRow[is-1] + rowStep;   
   
   //=================================================================
   //=================================================================
   int ic = is;
   //---- Trade result
   if (EATrading_Activ == true) {
      rowTrade_Result = ic; yRow[ic] = yRow[ic-1] + rowStep;
   }
   else 
      ic--;
   //---- Single Currencies
   ic++;
   rowSingleTitle = ic; yRow[ic] = yRow[ic-1] + rowStep;
   ic++;
   rowSinglePairs = ic; yRow[ic] = yRow[ic-1] + rowStep;
   ic++;
   rowSingleTrend = ic; yRow[ic] = yRow[ic-1] + rowStep;
   //-- first column
   xColSingle[1] = 5;//50;
   int xColSingleStep = 40;   
   for (ic=2; ic<=nSinglePairs; ic++)
      xColSingle[ic] = xColSingle[ic-1] + xColSingleStep;

   //=================================================================
   //=================================================================
   //---- set Titles
   Title2[colDB_Pairs]     = "Pairs:";     Title1[colDB_Pairs] = "[" + NumberSymbols + "]";
   if (ShowColumn_CurrentPrice == true) {
      Title1[colDB_LastPrice] = "Current"; Title2[colDB_LastPrice] = "Price"; 
   }
   
   if (EATrading_Activ == true)
      {Title1[colTrade_Arrow] = "Trade";  Title2[colTrade_Arrow] = "";}
      Title1[colTrade_Entry] = "";       Title2[colTrade_Entry] = "Entry";   
      Title1[colTrade_SL]    = "Stop";   Title2[colTrade_SL]    = "Loss";
   if (EATrading_Activ == true)   
      {Title1[colTrade_Win]   = "Win";    Title2[colTrade_Win]   = "("+AccountCurrency()+")";}
   
   Title1[iColDB_FirstTF]= "TFs Trend";    Title2[iColDB_FirstTF] = "";  
   
   Title1[colDB_ATR]    = "";        Title2[colDB_ATR]    = "ATR"; 
   Title1[colDB_Spread] = "Pair";    Title2[colDB_Spread] = "Sprd";   
   Title1[colCombiTFs]  = "Combi";   Title2[colCombiTFs]  = "Trend";
   Title1[colUpperTFs]  = "Main";    Title2[colUpperTFs]  = "Trend";
   return;
}

//-------------------------------------------------------------------
//    Get MarketInformations Values
//-------------------------------------------------------------------
void Get_MarketInfoValues()
{   
   for (int is=0; is <=NumberSymbols; is++) {
      string sSymbol = Pair[is];
      if (sSymbol != "") {
         //---- spread
         PairSpread[is] = MarketInfo(sSymbol, MODE_SPREAD) * MarketInfo(sSymbol, MODE_POINT);         
         PairDigits[is] = MarketInfo(sSymbol, MODE_DIGITS);
         PairPoint[is]  = MarketInfo(sSymbol, MODE_POINT);
         //PairPoint[is]  = MarketInfo(sSymbol, MODE_POINT)*MathPow(10,PairDigits[is]%2);    
         Pair_HiLoOffset[is] = Offset_EntryPoints * PairPoint[is];      
      }   
   }
   return;   
}

//-------------------------------------------------------------------
//    Show Titles Upper
//-------------------------------------------------------------------
void Show_TitlesUpper()   
{  
   int xx1, xx2;  
   //-- write titles
   for (int i=1; i<=iColDB_FirstTF; i++) {
      xx1 = xCol[i];
      xx2 = xx1;     
      if (Title1[i] != "") 
        SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
        SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);        
   }   
   
   //-- write title ATR
   if (ShowColumn_ATR == true) {
      i = colDB_ATR;
      xx1 = xCol[i];
      xx2 = xx1;    
      if (Title1[i] != "") 
         SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
         SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);   
   }
   
   //-- write title spread
   if (ShowColumn_PairSpread == true) {
      i = colDB_Spread;
      xx1 = xCol[i];
      xx2 = xx1;    
      if (Title1[i] != "") 
         SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
         SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);
   }

   //-- write title main trend
   if (ShowColumn_MainTrend == true) {
      i = colUpperTFs;
      xx1 = xCol[i];
      xx2 = xx1;    
      if (Title1[i] != "") 
         SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
         SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);
   }
   
   //-- write title combi trend
   if (ShowColumn_CombiTrend == true) {      
      i = colCombiTFs;
      xx1 = xCol[i];
      xx2 = xx1;    
      if (Title1[i] != "") 
         SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
         SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);   
   }
   return;
}

//-------------------------------------------------------------------
//    Show Titles Left Ranked
//-------------------------------------------------------------------
void Show_TitlesLeftRanked(int iRow, int is)
{   
   string sSymbol = Pair[is];
   if (iRow<10) string sNr = "0" + iRow + ". "; else sNr = iRow + ". ";
   string sNrSymbol = sNr + sSymbol;
   //-- write Names
   if (sSymbol != "")
      SetLabelObject(sLabelCode+sSymbol, sNrSymbol, colorTitle, xLeftTitle, yRow[iRow]);
      
   //-- write ATR
   if (ShowColumn_ATR == true) {
      double dATR    = myHighLowDistance[is][Column_SignalEvaluation_MTF] / PairPoint[is];
      string sATR = DoubleToStr(dATR,0);
      if (sSymbol != "")
         SetLabelObject(sLabelCode+sSymbol+"_ATR", sATR, colorTitle, xCol[colDB_ATR]+5, yRow[iRow]);
   }   
   //-- write Spreads
   if (ShowColumn_PairSpread == true) {
      string Spread = PairSpread[is];
      if (sSymbol != "")
         SetLabelObject(sLabelCode+sSymbol+"_Spread", Spread, colorTitle, xCol[colDB_Spread]+10, yRow[iRow]);
   }
   return;
}

//-------------------------------------------------------------------
//    Show Only Prices Ranked
//-------------------------------------------------------------------
void Show_CurrentPriceRanked(int iRow, int is)
{
   if (ShowColumn_CurrentPrice == false) return;
      
   string sSymbol = Pair[is];
   double dClose, dOpen;
   color dColor;
   int iDigits = PairDigits[is];      
      
   //-- Current Price
   dClose = iClose(sSymbol,TimeFrame,0);
   dOpen  = iOpen(sSymbol,TimeFrame,0);
   PairPrice[is] = dClose;
   if (dClose >= dOpen) dColor = Green; else dColor = Red; 
   if (sSymbol != "")     
      SetLabelObject(sLabelCode+sSymbol+"_CurrClose", DoubleToStr(dClose,iDigits),  dColor, xCol[colDB_LastPrice], yRow[iRow]);
   return;
}


//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//|      Delete Text Objects
//+------------------------------------------------------------------+
void Delete_TextObjects()
{
   ObjectsDeleteAll(iWindow,OBJ_LABEL);
   ObjectsDeleteAll(iWindow,OBJ_TEXT);
   ObjectsDeleteAll(iWindow,OBJ_ARROW);
   ObjectsDeleteAll(iWindow,OBJ_HLINE);
   ObjectsDeleteAll(iWindow,OBJ_VLINE);
   return;
}

//+------------------------------------------------------------------+
//| Set Label Object
//+------------------------------------------------------------------+
void SetLabelObject(string sName, string sText, color dColor, int xx, int yy)
{
   DeleteObject(sName);
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
        //ObjectSetText(sName,sText,rowTextHeight, "Courier New", dColor);
        ObjectSetText(sName,sText,rowTextHeight, "Arial Bold", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
   return;     
}

//+------------------------------------------------------------------+
//| Set Label Object Values
//+------------------------------------------------------------------+
void SetLabelObjectValues(string sName, string sText, color dColor, int xx, int yy)
{
   DeleteObject(sName);
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
        ObjectSetText(sName,sText,rowValueHeight, "Courier New", dColor);
        //ObjectSetText(sName,sText,rowTextHeight, "Arial Bold", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
   return;     
}

//+------------------------------------------------------------------+
//| Set Time Object
//+------------------------------------------------------------------+
void SetTimeObject(string sName, string sText, color dColor, int xx, int yy)
{   
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
        ObjectSetText(sName,sText,7, "Arial Bold", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
   return;     
}

//+------------------------------------------------------------------+
//| Set Arrow Object
//+------------------------------------------------------------------+
void SetArrowObject(string sName, int ArrowCode, int iHeight, color dColor, int xx, int yy)
{
   DeleteObject(sName);
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
   ObjectSetText(sName,CharToStr(ArrowCode),iHeight, "Wingdings", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
   return;     
}

//+------------------------------------------------------------------+
//| Delete Object
//+------------------------------------------------------------------+
void DeleteObject(string sName)
{
   int nObjects = ObjectsTotal();
   for (int i=0; i<nObjects; i++)
   {
      string nameObject = ObjectName(i);
      if (StringFind(nameObject,sName,0) >= 0) {
         ObjectDelete(nameObject);
         break;
      }   
   }
   return;   
}



//+------------------------------------------------------------------+
//| Get TimeFrame List Values
//+------------------------------------------------------------------+
void Get_TimeFrameListValues()
{
   int i,j,k;
   string CurTimeFrame;
   NumberTimeFrames = 0;
   
   for (i=0, j=0, k=1; i<nTitles && k>0;)
   {
      k=StringFind(TimeFrameList,",",j);
      if (k==0) CurTimeFrame=StringSubstr(TimeFrameList,j,0);
      else CurTimeFrame=StringSubstr(TimeFrameList,j,k-j);   
        
      if (CurTimeFrame != "")
      {  
         NumberTimeFrames++;
         iTimeFrame[NumberTimeFrames] = StrToInteger(CurTimeFrame);
      }
      i++;
          
      j=StringFind(TimeFrameList,",",j)+1;
      if (j==0) break;
   }   
   iLastPeriod = iTimeFrame[NumberTimeFrames];
   //---- alert column
   TimeFrame_Alert = iTimeFrame[Column_SignalEvaluation_MTF];
   if (TimeFrame_Alert == 0) TimeFrame_Alert = iTimeFrame[1];
   if (Column_SignalEvaluation_MTF == 0) Column_SignalEvaluation_MTF = 1;
   return;
}




//+------------------------------------------------------------------+
//|      Get PairList Names
//+------------------------------------------------------------------+
void Get_PairListNames(string PairsList)
{
   int i,j,k;
   string CurSymbol, CurSymbolSuff;
   double dClose;   
   
   for (i=0, j=0, k=1; i<nTitles && k>0;)
   {
      k=StringFind(PairsList,",",j);
      if (k==0) 
           CurSymbol=StringSubstr(PairsList,j,0);
      else CurSymbol=StringSubstr(PairsList,j,k-j);
      //---- set uppercase for the names in the extern parameter list
      //CurSymbol = Set_SymbolUppercase(CurSymbol);      
      if (CurSymbol != "") {
         CurSymbolSuff = CurSymbol + SymbolSuffix;
         //---- 1. check if CurSymbolSuff is allowable ------------------
         //---- check suffix and current
         if (SymbolSuffix != "")
         {
            //---- check if CurSymbol is allowable
            dClose = iClose(CurSymbolSuff,Period(),0);      
            if (dClose > 0.0) {
               i++;
               NumberSymbols++;
               //nDigits[NumberSymbols] = MarketInfo(CurSymbolSuff,MODE_DIGITS);
               Pair[NumberSymbols]=CurSymbolSuff;            
            } 
            else
            {    
               //---- check if CurSymbol is allowable
               dClose = iClose(CurSymbol,Period(),0);      
               if (dClose > 0.0) {
                  i++;
                  NumberSymbols++;
                  //nDigits[NumberSymbols] = MarketInfo(CurSymbol,MODE_DIGITS);
                  Pair[NumberSymbols]=CurSymbol;            
               }
            }
         }
         else
         //---- 2. check if CurSymbol is allowable ----------------------
         //---- check only current
         {
            dClose = iClose(CurSymbol,Period(),0);      
            if (dClose > 0.0) {
               i++;
               NumberSymbols++;
               //nDigits[NumberSymbols] = MarketInfo(CurSymbol,MODE_DIGITS);
               Pair[NumberSymbols]=CurSymbol;            
            }
         }
         j=StringFind(PairsList,",",j)+1;
         if (j==0) break;
      }
   }
   //---- max traded Symbols
   if (MaxEntryRanking < 0)  nMaxEntryRanking = NumberSymbols;
   else
   if (MaxEntryRanking == 0) nMaxEntryRanking = MathRound(NumberSymbols/2);
   else
                             nMaxEntryRanking = MaxEntryRanking;   
   return;
}

//+------------------------------------------------------------------+
//    Get Single Pairs
//+------------------------------------------------------------------+
void Get_SinglePairs()
{
int i, j;
   nSinglePairs = 0;
   for (j=1; j<=nTitles; j++)
      SinglePairs[j] = "";
   for (i=1; i<=NumberSymbols; i++) {
      string sSymbol = Pair[i];
      string s1 = StringSubstr(sSymbol,0,3);
      string s2 = StringSubstr(sSymbol,3,3);
 
      //-- pair 1
      for (j=1; j<=nTitles; j++) {
         if (s1 == SinglePairs[j]) break;
         else
         if (s1 != SinglePairs[j] && SinglePairs[j] == "") {
            SinglePairs[j] = s1;
            nSinglePairs++; 
            break;
         }
      }
      //-- pair 2
      for (j=1; j<=nTitles; j++) {
         if (s2 == SinglePairs[j]) break;
         else 
         if (s2 != SinglePairs[j] && SinglePairs[j] == "") {
            SinglePairs[j] = s2;
            nSinglePairs++; 
            break;
         }
      }
   }
   return;
}


/*
//+------------------------------------------------------------------+
//    Set Symbol Uppercase
//+------------------------------------------------------------------+
string Set_SymbolUppercase(string sText)
{
   int Len = StringLen(sText);
   for (int i=0; i<Len; i++) {
      if (i < 6) 
      {
         int iChar = StringGetChar(sText, i);
         if (iChar >= 97 && iChar <=122) 
            sText = StringSetChar(sText, i, iChar - 32);         
      }
   }
   return(sText);
}*/

//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Send Alerts 
//+------------------------------------------------------------------+
void SendAlerts(int iOrderType, string sSymbol, int iPeriod, string sPeriod, string sPrice, string sInitialSL, int i, int col, int iRank)
{
   if (SendAlert_Signals == false && SendEmail_Signals == false && PrintAlert_Signals == false) return;   

   string st, st2;
   string sTime  = "  " + TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS) + "  ";
   string sRank  = "  [" + iRank + "]";
   string sPeriodAlert = " (" + sPeriod + ") ";
   
   if (iOrderType > 0) st = "Buy ";
   else
   if (iOrderType < 0) st = "Sell ";
   
   st = st + sSymbol + "  " + sPrice + "  SL=" + sInitialSL;
   st2 =sRank  + sTime + sPeriodAlert + sTextAlert;
   st = st + st2;

   if (SendAlert_Signals == true) Alert(st);   
   if (SendEmail_Signals == true) SendMail(subjectEmailAlert, st);
//nur EAs!   if (PrintAlert_Signals== true) Print("##" + st);   
//   if (PlayAlert_Sound == true) PlayAlertSound();
   
   AlertSignal[i][col] = 0;
   return;
}
/*
//+------------------------------------------------------------------+
//    Play Alert Sound; Achtung! funktioniert nur in EAs
//+------------------------------------------------------------------+
void PlayAlertSound()
{
int TimeToSleep = 1000;
   PlaySound("alert.wav"); Sleep(TimeToSleep);
   PlaySound("stops.wav"); Sleep(TimeToSleep);
   PlaySound("news.wav"); Sleep(TimeToSleep);
   PlaySound("wait.wav"); Sleep(TimeToSleep);
   PlaySound("timeout.wav"); Sleep(TimeToSleep);
   PlaySound("alert.wav"); Sleep(TimeToSleep);
}*/


//+------------------------------------------------------------------+
//    Get sPeriod
//+------------------------------------------------------------------+
string Get_sPeriod(int timeframe)
{
   if (timeframe == PERIOD_M1) return("M1");
   if (timeframe == PERIOD_M5) return("M5");
   if (timeframe == PERIOD_M15) return("M15");
   if (timeframe == PERIOD_M30) return("M30");
   if (timeframe == PERIOD_H1) return("H1");
   if (timeframe == PERIOD_H4) return("H4");
   if (timeframe == PERIOD_D1) return("D1");
   if (timeframe == PERIOD_W1) return("W1");
   if (timeframe == PERIOD_MN1) return("MN1");
}


//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Get Symbol Suffix
//+------------------------------------------------------------------+
string Get_SymbolSuffix(string sSymbol)
{
   int Len = StringLen(sSymbol);
   if (Len <= 6) return("");
   
   int iChar = StringGetChar(sSymbol, Len-1);
   
   string sChar = "x";
   sChar = StringSetChar(sChar,0,iChar);
   
   sSuffix = StringSubstr(sSymbol,6,Len-5);  
   return(sSuffix);
}



//####################################################################
//+------------------------------------------------------------------+
//| Write Current Time
//+------------------------------------------------------------------+
void Write_CurrentTime(int xx, int yy)
{
   string st = "";
   string sTime = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES);
   string sTimeFrame = Get_sPeriod(TimeFrame_Alert);

   st = st + sTime;
   if (ShiftSignals == 0) {
      string sTimeFrame_Alert = Get_sPeriod(TimeFrame_Alert);
      st = st + "  ( " + sTimeFrame_Alert + " signals, refresh " + refreshPeriod + " min )";
   }   
   else
   if (ShiftSignals == 1) 
      st = st + "  ( signals " + ShiftSignals + " bar ago )"; 
   else
      st = st + "  ( signals " + ShiftSignals + " bars ago )";   
   SetTimeObject(sLabelCode+"time", st, colorTime, xx, yy);
   
   //---- write time frames
   if (Column_SignalEvaluation_MTF == 1)
        st = "(" + Get_sPeriod(iTimeFrame[1]) + ")";
   else st =       Get_sPeriod(iTimeFrame[1]);
   st = "Timeframes: " + st+", ";
   
   for (int it=2; it<=NumberTimeFrames-1; it++) {
      if (Column_SignalEvaluation_MTF == it)
           st = st + "(" + Get_sPeriod(iTimeFrame[it]) + ")"+",";
      else st = st +       Get_sPeriod(iTimeFrame[it])+",";      
   }   
   st = st + Get_sPeriod(iTimeFrame[NumberTimeFrames]);   
   SetLabelObject(sLabelCode+"_TFs", st, colorTitle, 2, 15);
/*
   //---- save picture ------------
   int Len = StringLen(sTime);
   for (int i=0; i<=Len; i++) {
      string sChar = StringSubstr(sTime,i,1);
      if (sChar == "." || sChar == ":" || sChar == " ")
         StringSetChar(sTime,i,'_');
   }   
   string sFile = sSignalsFile + ".gif";
   //string sFile = sSignalsFile + sTime + ".gif";
   WindowScreenShot(sFile,640,480);
*/   
/*
   //-- write time remaining ----------------------------------------
   if (Show_RestTimeUntilClose == false) return;
   int colText = iColDB_FirstTF;   
   for (int col = 1; col <= NumberTimeFrames; col++) {      
      datetime currentBarTime = iTime(Symbol(), iTimeFrame[col], 0);   
      int sec = iTimeFrame[col]*60  - (TimeCurrent()-currentBarTime);
      
      if (sec >= 0) {
         int iTF = colText + col;       
         string sName  = sLabelCode+"Title1_"+iTF;
         string sName2 = sLabelCode+"Title1TF_"+iTF;         
         string sTimeFrame2 = Get_sPeriod(iTimeFrame[col]);
         string sRestTime = TimeToStr(sec,TIME_MINUTES|TIME_SECONDS);         
      
         int xx1 = xCol[colText + col];
         //-- time frame
         ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
            ObjectSetText(sName,sTimeFrame2,HeightTF, "Arial Bold", colorTitle);
            ObjectSet(sName, OBJPROP_CORNER, 0);
            ObjectSet(sName, OBJPROP_XDISTANCE, xx1);
            ObjectSet(sName, OBJPROP_YDISTANCE, yTitle1);
         //-- rest time    
         ObjectCreate(sName2, OBJ_LABEL, iWindow, 0, 0);
            ObjectSetText(sName2,sRestTime,HeightTF, "Arial Bold", colorTitle);
            ObjectSet(sName2, OBJPROP_CORNER, 0);
            ObjectSet(sName2, OBJPROP_XDISTANCE, xx1);
            ObjectSet(sName2, OBJPROP_YDISTANCE, yTitle1 - rowStep);
      }  
   }*/
   return;
}





//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Get Hilo Mavg Trend
//+------------------------------------------------------------------+
void Get_HiloMavgTrend(string sSymbol, int iTF,
         int& iTrend, double& dMAvgHighs, double& dMAvgLows, int iBar)
{
int iPeriod = 21;
int iShift  = 1;  //HiLo averages shifted 1 bar
   //---- values
   double dClose  = iClose(sSymbol, iTF, iBar);
   double dHigh1  = iHigh(sSymbol, iTF, iBar+1);
   double dLow1   = iLow(sSymbol, iTF, iBar+1);
   
   dMAvgHighs  = iMA(sSymbol, iTF,iPeriod,iShift,MODE_SMA,PRICE_HIGH,iBar);
   dMAvgLows   = iMA(sSymbol, iTF,iPeriod,iShift,MODE_SMA,PRICE_LOW,iBar); 
   double dMAvgHighs1 = iMA(sSymbol, iTF,iPeriod,iShift,MODE_SMA,PRICE_HIGH,iBar+1);   
   double dMAvgLows1  = iMA(sSymbol, iTF,iPeriod,iShift,MODE_SMA,PRICE_LOW,iBar+1);

   //---- signals
   iTrend = 0;
   //-- long
   if (dHigh1 > dMAvgHighs1 &&
       dClose > dMAvgHighs)
      iTrend = 1; 
   else 
   //-- short
   if (dLow1  < dMAvgLows1 &&
       dClose < dMAvgLows)
      iTrend = -1;
   return;
}

//####################################################################
//+------------------------------------------------------------------+
//    Get Hull Trend
//+------------------------------------------------------------------+
void Get_HullTrend(string sSymbol, int iTF, int Hull_period,
         int& iTrend, double& HullValue, int iBar)
{
/*double trend, trend1, dUpTrend, dDnTrend, dExtHullBuffer;

   Internal_HullMAvg(sSymbol, iTF, iBar, 
                     trend, trend1, dUpTrend, dDnTrend, dExtHullBuffer,
                     Hull_period, Hull_periodDivisor, Hull_method, Hull_price);
   if (trend ==  1) {iTrend= 1; HullValue = dUpTrend;} else
   if (trend == -1) {iTrend=-1; HullValue = dDnTrend;}*/
   

   //---- Hull trend H1
   double UpTrend0 = iCustom(sSymbol, iTF,"smHull Mavg",
                   Hull_period,Hull_periodDivisor,Hull_method,Hull_price,
                   0,iBar);
   double DnTrend0 = iCustom(sSymbol, iTF,"smHull Mavg",
                   Hull_period,Hull_periodDivisor,Hull_method,Hull_price,
                   1,iBar);
                   
   double UpTrend1 = iCustom(sSymbol, iTF,"smHull Mavg",
                   Hull_period,Hull_periodDivisor,Hull_method,Hull_price,
                   0,iBar+1);
   double DnTrend1 = iCustom(sSymbol, iTF,"smHull Mavg",
                   Hull_period,Hull_periodDivisor,Hull_method,Hull_price,
                   1,iBar+1);
                                      
   //---- signals
   if (UpTrend0 != DnTrend0) {
      if (UpTrend0 != EMPTY_VALUE) {iTrend=1; HullValue=UpTrend0;}
      else
      if (DnTrend0 != EMPTY_VALUE) {iTrend=-1; HullValue=DnTrend0;}
   }
   else {
      if (UpTrend1 != EMPTY_VALUE) {iTrend=1; HullValue=UpTrend1;}
      else
      if (DnTrend1 != EMPTY_VALUE) {iTrend=-1; HullValue=DnTrend1;}
   }
   return;
}

/*
//###################################################################
//###################################################################
//###################################################################
//+------------------------------------------------------------------+ 
//|      Internal HullMAvg
//+------------------------------------------------------------------+ 
void Internal_HullMAvg(string sSymbol, int iTF, int iBar, 
                       double& trend, double& trend1, double& dUpTrend, double& dDnTrend, double& dExtHullBuffer,
                       int Hull_period, double Hull_periodDivisor, int Hull_method, int Hull_price)
{
int i, e = 200; // nBars
double vect[];
static double dExtHullBuffer1;
ArraySetAsSeries(vect, true); ArrayResize(vect, e);    
  
   int p = MathFloor(MathSqrt(Hull_period));
   int perVector = MathFloor(Hull_period/Hull_periodDivisor);   
   
   //---- first Hull vector / 200 bars
   for(i = 0; i < e; i++) 
      vect[i] = 2*WMA(sSymbol, iTF, iBar+i, perVector, Hull_method, Hull_price) -
                  WMA(sSymbol, iTF, iBar+i, Hull_period, Hull_method, Hull_price);
  
   dExtHullBuffer  = iMAOnArray(vect, 0, p, 0, Hull_method, 0);
   dExtHullBuffer1 = iMAOnArray(vect, 0, p, 0, Hull_method, 1);

   trend1 = trend;
   if (dExtHullBuffer > dExtHullBuffer1) trend=1;
   if (dExtHullBuffer < dExtHullBuffer1) trend=-1;   

   if (trend > 0) {
      dUpTrend = dExtHullBuffer;
      dDnTrend = EMPTY_VALUE;
   }
   else
   if (trend < 0) {
      dDnTrend = dExtHullBuffer;
      dUpTrend = EMPTY_VALUE;
   }
   return;
}

//+------------------------------------------------------------------+ 
//|      WMA
//+------------------------------------------------------------------+ 
double WMA(string sSymbol, int iTF, int iBar, 
           int iPeriodAvg, int Hull_method, int Hull_price) 
{ 
   return(iMA(sSymbol, iTF, iPeriodAvg, 0, Hull_method, Hull_price, iBar));
} */

//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//|      Get Indicator Values
//+------------------------------------------------------------------+
void Get_IndicatorValues()
{
   //---- indicator values
   //---- all symbols
   for (int is=1; is<=NumberSymbols; is++) { 
      string sSymbol = Pair[is];
      
      //---- all time frames
      for (int col = 1; col <= NumberTimeFrames; col++) {
         //---- moving averages
         int iHighLowTrend;
         double dHighsAvg, dLowsAvg;
         Get_HiloMavgTrend(sSymbol,iTimeFrame[col],iHighLowTrend, dHighsAvg, dLowsAvg, ShiftSignals);         
         myHighLowTrend[is][col][1] = iHighLowTrend;
         myHighLowTrend[is][col][2] = dHighsAvg;
         myHighLowTrend[is][col][3] = dLowsAvg;
         myHighLowDistance[is][col] = dHighsAvg - dLowsAvg;
         
         //---- Hull average
         int iHullTrend;
         double dHullValue;
         Get_HullTrend(sSymbol,iTimeFrame[col], Hull_periodH1,iHullTrend, dHullValue, ShiftSignals);         
         myHullAvgTrend[is][col][1] = iHullTrend;
         myHullAvgTrend[is][col][2] = dHullValue;
         //---- Hull average signal line
         Get_HullTrend(sSymbol,iTimeFrame[col], Hull_periodM1, iHullTrend, dHullValue, ShiftSignals);         
         myHullAvgSignal[is][col][1] = iHullTrend;
         myHullAvgSignal[is][col][2] = dHullValue; 
      }
   }   
   return;
}

/*
//+------------------------------------------------------------------+
//    Get Initial Number Trade Signals
//+------------------------------------------------------------------+
void Get_InitialNumberTradeSignals()
{   
   //nTradeSignals[i]++;
}*/