//+------------------------------------------------------------------+
//|                                         BasketTrade DBEAv5.1.mq4 |
//|                                 Copyright  2009.06.12, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009.06.12, SwingMan"
#property link      ""
//#property indicator_chart_window
//#property indicator_separate_window

/*+------------------------------------------------------------------+
// BasketTrader DB
2009.06.01 v3.1 - like H1Scalper DB_EA v4.1 with changes...
                - calculation of composite pairs
                - ranked list saved in global variables for EA trading 
2009.06.04 v4.1 - Trading
2009.06.08 v4.2 - bugs fixed
2009.06.10 v4.3 - InitialSL, BreakEen, StrongStop calculated from OrderOpen Price
2009.06.11 v4.4 - space for columns when the symbols has suffix
2009.06.12 v5.1 - big bug for Hull calculation / iTimeFrame was false as parameter!
//+------------------------------------------------------------------*/

//---- extern inputs -------------------------------------------------
//- currency pairs
//extern string PairsList1 = "NZDJPY,AUDUSD,NZDUSD";
//extern string PairsList2 = "";
extern string PairsList1 = "AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURNZD,EURUSD,";
extern string PairsList2 = "GBPAUD,GBPCAD,GBPCHF,GBPJPY,GBPNZD,GBPUSD,NZDCAD,NZDCHF,NZDJPY,NZDUSD,USDCAD,USDCHF,USDJPY,";
extern string PairsList3 = "";
/*extern string PairsList1 = "AUDCAD,AUDJPY,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,";
extern string PairsList2 = "GBPCHF,GBPJPY,GBPUSD,NZDCHF,NZDJPY,NZDUSD,USDCAD,USDCHF,USDJPY,";
extern string PairsList3 = "";
*/
extern int TradingTF_5_15_30_60_240= 240;            //-- Factors between TFs
//extern string TimeFrameList = "1,5,30,240";        //  5 = 5, 6, 6
//extern string TimeFrameList = "5,15,60,240";       // 15 = 3, 4, 4
//extern string TimeFrameList = "5,30,240,1440";     // 30 = 6, 8, 6 
//extern string TimeFrameList = "15,60,240,1440";    // 60 = 4, 4, 6  Scalper +10/-5
extern string TimeFrameList = "60,240,1440,10080";   //240 = 4, 6, 5  Trading H1
extern int TrendTFs_234_1234 = 234;
extern int Column_SignalEvaluation_MTF = 2;
extern bool SendAlert_Signals  = true;
//extern bool PlayAlert_Sound  = true;
extern bool SendEmail_Signals  = false;
extern bool PrintAlert_Signals = false;
//extern int AlertPeriodBeforeBarClose = 5;
extern int refreshPeriod = PERIOD_M1; // refresh calculation
extern string ____Trading_Parameters____ = "";
extern bool EATrading_Activ = true;
extern int MaxEntryRanking = 0; //for 0 = 1/2 nSymbols; for -1 = all Symbols
extern double Min_Lots = 0.10;
extern int Offset_EntryPoints = 1;
extern int BreakEven_Points = 2;
extern double Factor_InitialStopLoss = 1.0;
extern double Factor_BreakEven = 0.5;
extern double Factor_HiloTrail = 1.0;
extern string ____Display_Parameters____ = "";
//~~extern bool Draw_IntermediateSignals = false;
extern bool Show_EntryValues = true;
extern bool Show_SingleCurrencies = true;
//extern bool Show_RestTimeUntilClose = true;
extern bool ShowColumn_CurrentPrice = true;
extern bool ShowColumn_ATR = true;
extern bool ShowColumn_PairSpread = true;
extern bool ShowColumn_CombiTrend = true;
extern bool ShowColumn_MainTrend = false;
//extern bool Read_OldSignalSequence = true;
extern int Display_Window = 0;
//--------------------------------------------------------------------

bool Reentry_AfterTrendExit = false;

//---- system parameters ---------------------------------------------
int    Nbars=3000;
//---- Hilo parameters
int period_HiLo = 21;
//---- Hull parameters
int Hull_periodH1 = 27;
int Hull_periodM1 = 8;
double Hull_periodDivisor = 1.5;
int Hull_method = 3;
int Hull_price  = 0;
//--------------------------------------------------------------------


int TimeFrame;
//---- constants
int MagicNumber = 90604;
string windowsName       = "BasketTrade DBEAv5.1";
string sTextAlert        = "BasketTrader";
string subjectEmailAlert = "BasketTrader";
string sLabelCode        = "Basket_";
string sSignalsFile = "BaskTrad_";
string EAComment = " [Basket:";

int nOffsetEntry = 1;
int ShiftSignals = 0;
int nTrendBars = 4;
int nTitles = 30;

//double limitOverBought = 80;
//double limitOverSold   = 20;
//---- Text parameters ----------------
int Corner_LeftUp  = 0;
int Corner_RightUp = 1;
int Corner_LeftDn  = 2;
int Corner_RightDn = 3;

//---- colors
color colorTitle         = DodgerBlue;
color colorTime          = White;
color colorPlusIndi      = Green;
color colorMinusIndi     = Red;
color colorPlusSignal    = DeepSkyBlue;
color colorMinusSignal   = Magenta;
color colorNeutralSignal = SandyBrown;

//---- distances ----------------
int xLeftTitle = 10;
int xCurrentTime = 2; //200; 

int yCurrentTime = 2; // = 15;
int yTitle1 = 30;
int yTitle2 = 50;

int colStep = 90;
int colStepTimeFrames = 120;
int colStepSpread  = 30;
int colStepD1Trend = 40;

int HeightTF = 9; //-- titles: M1, M5...
int spaceCurrentPrice_Column = 85;
int spaceSignal_Column = 50;
int spaceFirstTF_Column = 20;
int spaceTimeFrame_Columns = 12;
int rowStep = 17;
int rowTextHeight = 9;
int rowValueHeight = 10;

//---- buffers -----------------------
string Pair[30]; //Pairs array
double PairPrice[30];
int xCol[50], yRow[50];
string Title1[50], Title2[50];
int iTimeFrame[20];
string sTimeFrame[20];
//int nDigits[30];

//---- columns
int colDB_Pairs;
int colDB_LastPrice;
int colDB_Signals, iColDB_FirstTF;
int colDB_Spread, colDB_ATR;
int colCombiTFs, colUpperTFs;
//-- trading
int colTrade_Arrow, colTrade_Entry, colTrade_SL, colTrade_Win;
int rowTrade_Result;

//-- Signal buffers; 20 because colCombi=13; colMain=14 !!! 
double AlertSignal[30][20];
bool SignalSended[30];
datetime oldBarTime[20];
datetime oldSignalTime[30][20];
int nTradeSignals[30], nLastTradeSignals[30];

//-- MarketInformations ........................................
double PairSpread[30], PairPoint[30];
int PairDigits[30];
double Pair_HiLoOffset[30];
//-- System Buffers ............................................
double myHighLowTrend[30][20][5], myHighLowDistance[30][20];
double myHullAvgTrend[30][20][5], myHullAvgSignal[30][20][5];
double mySystemSignal[30][20][5];
double myRanking[30][20][5]; 

//---- composite pairs
string SinglePairs[20]; // = {"EUR","USD","CAD","JPY","GBP","CHF","AUD","NZD"};
int nSinglePairs;       // = 8;
double mySingleTrendSume[20][20][5];
int xColSingle[20];
int rowSinglePairs, rowSingleTrend, rowSingleTitle;

//---- variables
string SymbolSuffix = "";
int NumberSymbols, NumberTimeFrames;
int iWindow, iCorner;
datetime oldTime, thisTime;
bool CurrentTimeFrameOK, bInitialSignalsCalculated, bStartenOK;
string sSuffix;
double dSpreadFactor;
int iRound;
int iLastPeriod, TimeFrame_Alert, Trading_TimeFrame;
int iSignalFile;

//---- trading
//string sNameStopLine = "StopLine_";
int TradingSignal[30], DisplaySignal[30];
double StopLossTrade[30], BreakEvenStop[30], StrongStopLoss[30], InitialStopLoss[30];
int nMaxEntryRanking;
//---- includes
#include <BasketTR_CommonsInclude.mqh>
#include <BasketTR_OrderInclude.mqh>
#include <BasketTR_TradingInclude.mqh>

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{  
   iCorner = Corner_LeftUp;
   CurrentTimeFrameOK = false;
   TimeFrame = Period();
   oldTime = 0;
   NumberSymbols = 0;
   bInitialSignalsCalculated = false;   
   bStartenOK = true;
   
   //---- check DemoAccount
   if (IsDemo() == false) {
      bStartenOK = false;
      EATrading_Activ = false;
      Alert("Automatic TradingEA works only on Demo Accounts!");
      //return(0);
   }
   //---- check display window
   iWindow = Display_Window;
   if (Display_Window > 0) {
      int nWindows = WindowsTotal();
      if (nWindows == 0) {
         bStartenOK = false;
         Alert("You need to have a separate window!");
         return(0);
      }
      else
      if (Display_Window > nWindows) {
         bStartenOK = false;
         Alert("The Display_Window number (" + Display_Window + ") is greather as WindowsTotal= ",nWindows);
         return(0);
      }
   } 
   
   //-- clear Titles
   for (int i=0; i<=50; i++) {
      Title1[i] = "";
      Title2[i] = "";
   }
   //-- clear Time Frames
   for (i=0; i<=10; i++) {
      iTimeFrame[i] = 0;
      sTimeFrame[i] = "";      
   } 
   //-- clear signals sended
   for (i=0; i <=nTitles; i++)
      SignalSended[i] = false;

   SymbolSuffix = Get_SymbolSuffix(Symbol());
   
//   int iDigits = MarketInfo(Symbol(), MODE_DIGITS);
//   if (iDigits == 3 || iDigits == 5)   {
//      dSpreadFactor = 0.1;
//      iRound = 1;
//   }
//   else {   
      dSpreadFactor = 1; 
      iRound = 0;
//   }
   
   //---- time frame lists
   Trading_TimeFrame = TradingTF_5_15_30_60_240;
   if (Trading_TimeFrame != 0) {
      if (Trading_TimeFrame ==   5) TimeFrameList = "1,5,30,240";     else //  5 = Scalping M5
      if (Trading_TimeFrame ==  15) TimeFrameList = "5,15,60,240";    else // 15
      if (Trading_TimeFrame ==  30) TimeFrameList = "5,30,240,1440";  else // 30
      if (Trading_TimeFrame ==  60) TimeFrameList = "15,60,240,1440"; else // 60 = Trading H1
      if (Trading_TimeFrame == 240) TimeFrameList = "60,240,1440,10080";   // 240
   }
   
   //---- titles   
   Get_TimeFrameListValues();
   Get_PairListNames(PairsList1);
   Get_PairListNames(PairsList2);
   Get_PairListNames(PairsList3);
   Get_SinglePairs();
   
   Get_MarketInfoValues();
   Set_DisplayInitialisations();   
   Show_TitlesUpper();   
   
  
   //---- read old signals from file ================================
   /*if (Read_OldSignalSequence == true) {
      string  sSignalsFileR;
      int iOldSignal;
      sSignalsFileR = sSignalsFile + Trading_TimeFrame + ".dat";
      iSignalFile = FileOpen(sSignalsFileR,FILE_BIN|FILE_READ);
      if (iSignalFile!=-1) {
         for (i=1; i<=NumberSymbols; i++) { 
            iOldSignal = FileReadInteger(iSignalFile);
            nTradeSignals[i] = iOldSignal;
         }   
         FileClose(iSignalFile);      
      }
   }*/
//----
   return(0); 
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{  
   Delete_TextObjects();
   Sleep(100);
   Delete_TextObjects();   
   Comment("");
   
   //---- write old signals to file ================================   
   string sSignalsFileW = sSignalsFile + Trading_TimeFrame + ".dat";
   if (iSignalFile != -1) FileDelete(iSignalFile);   
   iSignalFile = FileOpen(sSignalsFileW,FILE_BIN|FILE_WRITE);
   for (int ir=1; ir<=NumberSymbols; ir++) { 
      for (int col = 1; col <= NumberTimeFrames; col++) {  
         int i = myRanking[ir][col][0];
         FileWriteInteger(iSignalFile, nTradeSignals[i]);
      }
   }   
   FileClose(iSignalFile);   
//----
   return(0);
}


//####################################################################
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  
//return(0);
//   if (bStartenOK == false) return(0);
   
   //-- refresh every minute
   thisTime = iTime(Symbol(), refreshPeriod, 0);
   if (thisTime == oldTime) return(0);
   oldTime = thisTime;

   //---- titles   
   if (NumberTimeFrames == 0)
      Get_TimeFrameListValues();
   if (NumberSymbols == 0) {   
      Get_PairListNames(PairsList1);
      Get_PairListNames(PairsList2);
      Get_PairListNames(PairsList3);      
      Get_SinglePairs();
      
      Get_MarketInfoValues();
      Set_DisplayInitialisations();   
      Show_TitlesUpper();
   }

   Write_CurrentTime(xCurrentTime, yCurrentTime);
     
   //---- old calculated signals
   /*if (bInitialSignalsCalculated == false) {
     Get_InitialNumberTradeSignals();
     bInitialSignalsCalculated = true;
   }*/
   
   //================================================================
   //---- 1. check trading exits   
   if (EATrading_Activ == true) {
      Get_ActivOrder(MagicNumber);      //OrderInclude
      Check_ExitOrder();                //TradingInclude
      //   Display_TradingOrders();          //TradingInclude
   }
   
   //================================================================
   //---- 2. calculate indicators 
   Get_IndicatorValues();
   Get_TrendRanking();   
   Get_CompositeRanking();
   
   Get_SignalValues();
   Draw_IndicatorValues();

   Draw_NumberTradingSignals();
   
   //================================================================
   //---- 3. check send new order, set initial stop loss
   if (EATrading_Activ == true) {
      Get_ActivOrder(MagicNumber); //to identify free positions
      Check_SendNewOrder();        //TradingInclude
      Get_ActivOrder(MagicNumber); //OrderInclude
      Set_InitialStopLoss();       //TradingInclude
      Set_NewStopLoss();           //TradingInclude
      Display_TradingOrders();     //TradingInclude
   }
     
   return(0);
}
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//    Get Signal Values
//+------------------------------------------------------------------+
void Get_SignalValues()
{
   //---- all symbols
   for (int is=1; is<=NumberSymbols; is++) { 
      string sSymbol = Pair[is];
      
      //---- all time frames
      for (int col = 1; col <= NumberTimeFrames; col++) {   
         double dOpen  = iOpen(sSymbol, iTimeFrame[col],ShiftSignals);
         double dClose = iClose(sSymbol,iTimeFrame[col],ShiftSignals);
         
         //-- INDICATORS
         //==========================================================
         //-- 1. HullTrend value ------------------------------------
         int iValue_HullTrend = myHullAvgTrend[is][col][1];
         int iValue_HullSignal= myHullAvgSignal[is][col][1];

         //-- 2. HighLow values -------------------------------------
         int iValue_HighLowTrend = myHighLowTrend[is][col][1];
        
         //-- 4. Hull Position values -------------------------------
         int iValue_HullPosition = 0;
         if (myHullAvgTrend[is][col][2] > myHighLowTrend[is][col][2]) iValue_HullPosition = 1;
         else
         if (myHullAvgTrend[is][col][2] < myHighLowTrend[is][col][3]) iValue_HullPosition = -1;
         
         //-- 5. Bar colour values -------------------------------
         int iValue_BarColour = 0;
         if (dClose > dOpen) iValue_BarColour =  1; else
         if (dClose < dOpen) iValue_BarColour = -1;
                 
         //-- SIGNALS
         //==========================================================
         int iOrderType = 0;
         
         //---- EntrySignal
         int EntrySignal = 0;
         if (iValue_HullSignal ==  1 && iValue_BarColour ==  1) EntrySignal =  1; else
         if (iValue_HullSignal == -1 && iValue_BarColour == -1) EntrySignal = -1;
                  
         //---- signals
         //-- long .................................................
         if (iValue_HullTrend ==1) {
            //==== Signal = 4 -> Entry long OK
            if (EntrySignal == 1) {
               iOrderType=4;
            }
            else
            //==== Signal = 3
            if (iValue_HullPosition ==1 && iValue_HighLowTrend ==1) {   
               iOrderType=3;
            }      
            else
            //==== Signal = 2
            if (iValue_HullPosition == 1 || iValue_HighLowTrend ==1) {
               iOrderType=2;
            }     
            else
            //==== Signal = 1   
               iOrderType=1;
         }
         else
         
         //-- short ................................................
         if (iValue_HullTrend ==-1) {
            //==== Signal = -4 -> Entry short OK
            if (EntrySignal == -1) {
               iOrderType=-4;
            }
            else   
            //==== Signal = -3
            if(iValue_HullPosition ==-1 && iValue_HighLowTrend ==-1) {      
               iOrderType=-3;
            }      
            else
            //==== Signal = -2
            if (iValue_HullPosition == -1 || iValue_HighLowTrend ==-1) {   
                iOrderType=-2;
            }   
            else
            //==== Signal = -1
                iOrderType=-1;    
         }
         mySystemSignal[is][col][1] = iOrderType;
      }
//if (sSymbol=="CHFJPY")
//Comment("\n\n\n",mySystemSignal[is][1][1],mySystemSignal[is][2][1],mySystemSignal[is][3][1],mySystemSignal[is][4][1]);         
   }

   return;
}

//+------------------------------------------------------------------+
//    Get Trend Ranking
//+------------------------------------------------------------------+
void Get_TrendRanking()
{
int i, is, col;
string sSymbol;
double dHullValue;
double sumFXupper, sumWeighted;
double f1, factorTF[6];
   //---- factors
   f1 = 1.618;
   factorTF[1] = f1;
   for (i=2; i<=6; i++) 
      factorTF[i] = factorTF[i-1] * f1;
   //-- Time frames 2,3,4
   sumFXupper = 0;
   if (TrendTFs_234_1234 == 234) {
      for (i=1; i <=NumberTimeFrames-1; i++)
         sumFXupper = sumFXupper + factorTF[i];
   }   
   else
   //-- Time frames 1,2,3,4
   if (TrendTFs_234_1234 == 1234) {
      for (i=1; i <=NumberTimeFrames; i++)
         sumFXupper = sumFXupper + factorTF[i];
   } 
      
   //################################################################
   //---- trends for all time frames: (Hull[0] - Hull[4])/ (ATR + Spread)
   for (is=1; is<=NumberSymbols; is++) { 
      sSymbol = Pair[is];
      for (col = 1; col <= NumberTimeFrames; col++) {            
         //---- Hull average
         dHullValue = myHullAvgTrend[is][col][2];
         
         int iHullTrend4;
         double dHullValue4;
         double dATR = iATR(sSymbol, iTimeFrame[col], 34, 1);
         double dSpread = PairSpread[is];
         Get_HullTrend(sSymbol,iTimeFrame[col],Hull_periodH1,iHullTrend4, dHullValue4, ShiftSignals + nTrendBars);
         myHullAvgTrend[is][col][3] = 100*(dHullValue - dHullValue4)/(dATR + dSpread);
      
         myRanking[is][col][0] = is;
         myRanking[is][col][1] = myHullAvgTrend[is][col][3];
         myRanking[is][col][2] = myHullAvgTrend[is][col][3];
      }
   }
   //---- sum of trends for upper time frames
   for (is=1; is<=NumberSymbols; is++) { 
      sumWeighted = 0;
      //-- columns 2, 3, 4 in colUpperTFs
      if (TrendTFs_234_1234 == 234) {
         for (i=2; i<=NumberTimeFrames; i++)
            sumWeighted = sumWeighted + factorTF[NumberTimeFrames - i + 1] * myRanking[is][i][1];            
         sumWeighted = sumWeighted / sumFXupper;
         myRanking[is][colUpperTFs][0] = is;
         myRanking[is][colUpperTFs][1] = sumWeighted; // for ranking abs values
         myRanking[is][colUpperTFs][2] = sumWeighted; // for display values
      }
      else
      //-- columns 1, 2, 3, 4 in colUpperTFs
      if (TrendTFs_234_1234 == 1234) {
         for (i=1; i<=NumberTimeFrames; i++)
            sumWeighted = sumWeighted + factorTF[NumberTimeFrames - i + 1] * myRanking[is][i][1];            
         sumWeighted = sumWeighted / sumFXupper;
         myRanking[is][colUpperTFs][0] = is;
         myRanking[is][colUpperTFs][1] = sumWeighted;
         myRanking[is][colUpperTFs][2] = sumWeighted;
      }
   }
   //================================================================  
   //---- ranking trends; only the weighted trend   
   col = colUpperTFs;
   //for (col = 1; col <= NumberTimeFrames+1; col++) {     
      for (is=1; is<=NumberSymbols; is++) {      
         for (int j=1; j<=is; j++)
         {
            double dCurrentRange  = MathAbs(myRanking[is][col][0]);
            double dCurrentValue  = MathAbs(myRanking[is][col][1]);
      
            double dRankRange    = MathAbs(myRanking[j][col][0]);
            double dRankValue    = MathAbs(myRanking[j][col][1]);
         
            if (dRankValue < dCurrentValue)            //-- condition current value > cell value
            {
               double dTempRange    = dCurrentRange;   //-- save cell value in temp value
               double dTempValue    = dCurrentValue;
            
               myRanking[is][col][0] = dRankRange;      //-- cell value = current value
               myRanking[is][col][1] = dRankValue;
            
               myRanking[j][col][0] = dTempRange;      //-- test value = temp value
               myRanking[j][col][1] = dTempValue;            
            }
         }
      }
      //---- symbol rank in a column
      for (is=1; is<=NumberSymbols; is++) {
         j =  myRanking[is][col][0];   //-- symbol number
         myRanking[j][col][3] = is;    //-- rank number
      }
   //}
   return;  
}

//+------------------------------------------------------------------+
//    Get Composite Ranking
//+------------------------------------------------------------------+
void Get_CompositeRanking()   
{
int is, j;
double dTrendValue, numValues;
string sSymbol, s1, s2;

   int col = 1;
   //---- initialisation
   for (j=1; j<=nSinglePairs; j++) {
      mySingleTrendSume[j][col][1] = 0;
      mySingleTrendSume[j][col][2] = 0;
      mySingleTrendSume[j][col][3] = 0;
      mySingleTrendSume[j][col][4] = 0;
   }

   //---- sum of the single trends
   for (is=1; is<=NumberSymbols; is++) {
      sSymbol = Pair[is];
      s1 = StringSubstr(sSymbol,0,3);
      s2 = StringSubstr(sSymbol,3,3);
      dTrendValue = myRanking[is][colUpperTFs][2]; // weighted trend of the TFs
 
      //-- pair 1
      for (j=1; j<=nSinglePairs; j++) {
         if (s1 == SinglePairs[j]) {
            mySingleTrendSume[j][col][1] = mySingleTrendSume[j][col][1] + 1; // number of data
            mySingleTrendSume[j][col][2] = mySingleTrendSume[j][col][2] + dTrendValue;
            break;
         }
      }
      //-- pair 2
      for (j=1; j<=nSinglePairs; j++) {
         if (s2 == SinglePairs[j]) {
            mySingleTrendSume[j][col][1] = mySingleTrendSume[j][col][1] + 1; // number of data
            mySingleTrendSume[j][col][2] = mySingleTrendSume[j][col][2] - dTrendValue;
            break;
         }
      }
   }
   
   //---- middle value of the single trends
   for (j=1; j<=nSinglePairs; j++) {
      numValues = mySingleTrendSume[j][col][1];
      if (numValues > 0)
         mySingleTrendSume[j][col][2] = mySingleTrendSume[j][col][2] / numValues;
      else
         mySingleTrendSume[j][col][2] = 0;
   }
   
   //---- combine trend from single1 with single2 in a combined pair
   for (is=1; is<=NumberSymbols; is++) {
      sSymbol = Pair[is];
      s1 = StringSubstr(sSymbol,0,3);
      s2 = StringSubstr(sSymbol,3,3);
      
      dTrendValue = 0; 
      //-- pair 1
      for (j=1; j<=nSinglePairs; j++) {
         if (s1 == SinglePairs[j]) {
            dTrendValue = dTrendValue + mySingleTrendSume[j][col][2];
            break;
         }
      }
      //-- pair 2
      for (j=1; j<=nSinglePairs; j++) {
         if (s2 == SinglePairs[j]) {
            dTrendValue = dTrendValue - mySingleTrendSume[j][col][2];
            break;
         }
      }
      
      //---- combined trend values
      myRanking[is][colCombiTFs][0] = is;
      myRanking[is][colCombiTFs][1] = dTrendValue; // for ranking abs values
      myRanking[is][colCombiTFs][2] = dTrendValue; // for display
   }

   //---- ranking combined trends
   //================================================================
   col = colCombiTFs;
   for (is=1; is<=NumberSymbols; is++) {
      for (j=1; j<=is; j++)
      {
         double dCurrentRange  = MathAbs(myRanking[is][col][0]);
         double dCurrentValue  = MathAbs(myRanking[is][col][1]);
      
         double dRankRange    = MathAbs(myRanking[j][col][0]);
         double dRankValue    = MathAbs(myRanking[j][col][1]);
         
         if (dRankValue < dCurrentValue)            //-- condition current value > cell value
         {
            double dTempRange    = dCurrentRange;   //-- save cell value in temp value
            double dTempValue    = dCurrentValue;
            
            myRanking[is][col][0] = dRankRange;     //-- cell value = current value
            myRanking[is][col][1] = dRankValue;
            
            myRanking[j][col][0] = dTempRange;      //-- test value = temp value
            myRanking[j][col][1] = dTempValue;            
         }
      }
   }
   //---- symbol rank in a column
   for (is=1; is<=NumberSymbols; is++) {
      j =  myRanking[is][col][0];   //-- symbol number
      myRanking[j][col][3] = is;    //-- rank number
   }
   return;
}

//####################################################################
//####################################################################
//####################################################################
//+------------------------------------------------------------------+
//    Draw Indicator Values
//+------------------------------------------------------------------+
void Draw_IndicatorValues()
{
int iArrow, iHeight=8, iHeightSignal = 10, xStep=8;
color dColor;
int col, xSignal, xxt, iOrderType, iStep, xSig, iHght,  ir, is, j, Len;
string sNameArrow, TrendPercent, sSymbol;

   
//##############################################
//---- 0. Show Symbols
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];      
      sSymbol = Pair[is];
      Show_TitlesLeftRanked(ir, is); //-- iRow,  iTitle
      Show_CurrentPriceRanked(ir, is);
   }      
//Comment("\n\n",myRanking[3][colCombiTFs][2],"   ",myRanking[3][colUpperTFs][2]);
//##############################################
//---- 1. Combined Pairs Trend %
   if (ShowColumn_CombiTrend == true) 
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];
      sSymbol = Pair[is];   
      TrendPercent = DoubleToStr(myRanking[is][colCombiTFs][2],1); // combi trend
      Len = StringLen(TrendPercent);
      switch (Len) {
         case 3: TrendPercent = "    " + TrendPercent; break;
         case 4: TrendPercent = "   " + TrendPercent; break;
         case 5: TrendPercent = "  " + TrendPercent; break;
         case 6: TrendPercent = " " + TrendPercent; break;
      }       
      xxt = xCol[colCombiTFs]-20;
      SetLabelObjectValues("_D2Trend_"+yRow[ir], TrendPercent, colorTitle, xxt, yRow[ir]);         
   }

   
//##############################################
//---- 2. Main Trend of Time Frames %
   if (ShowColumn_MainTrend == true)
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];     
      sSymbol = Pair[is];
      TrendPercent = DoubleToStr(myRanking[is][colUpperTFs][2],1); // main trend
      Len = StringLen(TrendPercent);
      switch (Len) {
         case 3: TrendPercent = "    " + TrendPercent; break;
         case 4: TrendPercent = "   " + TrendPercent; break;
         case 5: TrendPercent = "  " + TrendPercent; break;
         case 6: TrendPercent = " " + TrendPercent; break;
      }         
      //-- rank changing; rank is in cell [3]
      double rankComb = myRanking[is][colCombiTFs][3]; string sRankComb = DoubleToStr(rankComb,0);
      double rankMain = myRanking[is][colUpperTFs][3]; string sRankMain = DoubleToStr(rankMain,0);      
      string sDir;
      if (rankComb > rankMain) sDir = "\\";  
      else
      if (rankComb < rankMain) sDir = "/"; 
      else                     sDir = "=";
      TrendPercent = TrendPercent + "(" + sRankComb +sDir + sRankMain + ")";
      xxt = xCol[colUpperTFs]-20;
      SetLabelObjectValues("_D1Trend_"+yRow[ir], TrendPercent, colorTitle, xxt, yRow[ir]); 
   }  
          
//##############################################
//---- write Spreads
   if (ShowColumn_PairSpread == true)
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];     
      sSymbol = Pair[is];
      string sSpread = DoubleToStr(PairSpread[is]/PairPoint[is],iRound);
      if (sSymbol != "")
         SetLabelObject(sLabelCode+sSymbol+"_Spread", sSpread, colorTitle, xCol[colDB_Spread]+10, yRow[ir]);
   }   
   
//##############################################################   
//---- Trend Arrows for Timeframes
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];     
      sSymbol = Pair[is];

      for (col = 1; col <= NumberTimeFrames; col++) {
         //---- signals
         iOrderType = mySystemSignal[is][col][1];         
         xSignal = xCol[iColDB_FirstTF + col-1];
         
         int xOffset = 12; 
         int yOffset = 2;
         int xx = xSignal + xOffset;

         //========================================================== 
         //-- long        
         if (iOrderType >= 1) {
            if (iOrderType == 4) {iArrow = 221; iHght = iHeightSignal;}   else  //-- entry
            if (iOrderType == 3) {iArrow = 241; iHght = iHeightSignal+1;} else  //-- wait
            if (iOrderType == 2) {iArrow = 225; iHght = iHeightSignal-1;} else  //-- wait
            if (iOrderType == 1) {iArrow = 217; iHght = iHeightSignal;}
            if (iOrderType == 4) dColor = colorPlusSignal; else dColor = colorPlusIndi;
            sNameArrow = sLabelCode+sSymbol+"_iSignal"+sTimeFrame[col];
            SetArrowObject(sNameArrow, iArrow, iHght, dColor, xSignal, yRow[ir]);
            /*//-- entry price long
            if (Show_EntryValues == true && col == 1) {
               string sPrice = Get_EntryPrice(iOrderType, sSymbol, iTimeFrame[col]);
               int yy = yRow[ir];
               sNameArrow = sLabelCode+sSymbol+"_dEntry"+sTimeFrame[col];
               SetLabelObject(sNameArrow, sPrice, dColor, xx, yy);
            }*/
            AlertSignal[is][col] = iOrderType;            
         }
         else
         //-- short
         if (iOrderType <= -1) {
            if (iOrderType == -4) {iArrow = 222; iHght = iHeightSignal;}   else  //-- entry
            if (iOrderType == -3) {iArrow = 242; iHght = iHeightSignal+1;} else  //-- wait
            if (iOrderType == -2) {iArrow = 226; iHght = iHeightSignal-1;} else  //-- wait
            if (iOrderType == -1) {iArrow = 218; iHght = iHeightSignal;}
            if (iOrderType == -4) dColor = colorMinusSignal; else dColor = colorMinusIndi;            
            sNameArrow = sLabelCode+sSymbol+"_iSignal"+sTimeFrame[col];
            SetArrowObject(sNameArrow, iArrow, iHght, dColor, xSignal, yRow[ir]);  
            /*//-- entry price short
            if (Show_EntryValues == true && col == 1) {
               sPrice = Get_EntryPrice(iOrderType, sSymbol, iTimeFrame[col]);
               yy = yRow[ir] - yOffset;
               sNameArrow = sLabelCode+sSymbol+"_dEntry"+sTimeFrame[col];
               SetLabelObject(sNameArrow, sPrice, dColor, xx, yy);
            }*/
            AlertSignal[is][col] = iOrderType;            
         }
         else
         if (iOrderType == 0) {
            iArrow = 251; dColor = colorNeutralSignal;         
            sNameArrow = sLabelCode+sSymbol+"_iSignal"+sTimeFrame[col];
            SetArrowObject(sNameArrow, iArrow, iHeight, dColor, xSignal, yRow[ir]);
         }
      }
   }
   
//##############################################
//---- Single Currencies / last rows
   dColor = colorTitle;
   col = 1;
   if (Show_SingleCurrencies == true) {      
      sNameArrow = sLabelCode+"SingTit";
      string sTitle = "Trend Strength of Single Currencies:";
      SetLabelObject(sNameArrow, sTitle, dColor, xColSingle[1], yRow[rowSingleTitle]);  
      
      for (j=1; j<=nSinglePairs; j++) {
         string sCurrencie = SinglePairs[j]+":"+DoubleToStr(mySingleTrendSume[j][col][1],0);
         sNameArrow = sLabelCode+sCurrencie+"_SingPair";
         SetLabelObject(sNameArrow, sCurrencie, dColor, xColSingle[j], yRow[rowSinglePairs]);  
         
         sNameArrow = sLabelCode+sCurrencie+"_SingTrnd";
         string sSingleTrend = DoubleToStr(mySingleTrendSume[j][col][2],1);
         SetLabelObject(sNameArrow, sSingleTrend, dColor, xColSingle[j], yRow[rowSingleTrend]); 
      }
   }
   return;
}

//-------------------------------------------------------------------
//    Draw Number Trading Signals
//-------------------------------------------------------------------
void Draw_NumberTradingSignals()
{
int ir, is;
datetime currentBarTime;   
color dColor;
string sNSignals, sPrice, sSignal, sInitialSL,sName;
double dLongValueEntry, dLongValueSL, dShortValueEntry, dShortValueSL;
int iArrow, k, iOrderType1, iColSignal, col, iDigits;
int iHeight = 8;
int xx = xCol[colDB_Signals];
   
   //---- signals
   for (ir=1; ir<=NumberSymbols; ir++) { 
      is = myRanking[ir][colCombiTFs][0];
      string sSymbol = Pair[is];
      sName = sLabelCode+sSymbol+"_nSignals";
              
      //---- column for evaluations
      col = Column_SignalEvaluation_MTF;
         
      //==========================================================
      //---- check new bar
      bool newBar = false;
      currentBarTime = iTime(sSymbol, iTimeFrame[col], 0);   
      if (currentBarTime != oldSignalTime[is][col]) {
         oldSignalTime[is][col] = currentBarTime;
         newBar = true;
         SignalSended[is] = false;
         nLastTradeSignals[is] = nTradeSignals[is];
      }         

      //==========================================================
      //---- 1. trading signal
      TradingSignal[is] = 0;
      //-- signal from column for evaluations
      iOrderType1 = mySystemSignal[is][col][1];
      //---- signals from all columns after signal column
      //-- all signals = 4 
      bool SignalAllTFs_Long = (iOrderType1 == 4);
      for (k = col+1; k <= NumberTimeFrames; k++)
         SignalAllTFs_Long = SignalAllTFs_Long && (mySystemSignal[is][k][1] == 4);
      if (SignalAllTFs_Long == true)   
         TradingSignal[is] = 1;   

      //-- all signals = -4
      bool SignalAllTFs_Short = (iOrderType1 == -4);
      for (k = col+1; k <= NumberTimeFrames; k++)
         SignalAllTFs_Short = SignalAllTFs_Short && (mySystemSignal[is][k][1] == -4);
      if (SignalAllTFs_Short == true)   
         TradingSignal[is] = -1;
         
      //==========================================================
      //---- 2. display signal
      DisplaySignal[is] = 0;
      //-- signal from column for evaluations
      iOrderType1 = mySystemSignal[is][col][1];
      //---- signals from all columns after signal column
      //-- all signals = 4 
      bool SignalDisplay_Long = (iOrderType1 > 1);
      for (k = col+1; k <= NumberTimeFrames; k++)
         SignalDisplay_Long = SignalDisplay_Long && (mySystemSignal[is][k][1] == 4);
      if (SignalDisplay_Long == true)   
         DisplaySignal[is] = 1;   

      //-- all signals = -4
      bool SignalDisplay_Short = (iOrderType1 < -1);
      for (k = col+1; k <= NumberTimeFrames; k++)
         SignalDisplay_Short = SignalDisplay_Short && (mySystemSignal[is][k][1] == -4);
      if (SignalDisplay_Short == true)   
         DisplaySignal[is] = -1;
         
      //==========================================================
      //==========================================================
      //==========================================================
      //---- Display TRADING Values
      dLongValueEntry  = Get_EntryPriceValue(is, sSymbol, 1);
      dLongValueSL     = Get_InitialStopLossValue(is, sSymbol, 1, dLongValueEntry);
      dShortValueEntry = Get_EntryPriceValue(is, sSymbol, -1);
      dShortValueSL    = Get_InitialStopLossValue(is, sSymbol, -1, dShortValueEntry);
//if (sSymbol=="CADJPY")
//Comment("\n\n\n", nActivOrders[is], "  ",dLongValueEntry,"  ",dLongValueSL,"  ");
      //---- only if the pair is not traded
      if (nActivOrders[is] == 0) {
//if (sSymbol=="CADJPY")
//Comment("\n\n\n", nActivOrders[is], "  ",dLongValueEntry,"  ",dLongValueSL,"  ");      
         //-- long
         if (DisplaySignal[is] == 1) {
            Display_EntrySLValues(ir, is, sSymbol, 1, dLongValueEntry, dLongValueSL);
         }
         else
         //-- short
         if (DisplaySignal[is] == -1) {
            Display_EntrySLValues(ir, is, sSymbol, -1, dShortValueEntry, dShortValueSL);
         }
         else
         if (DisplaySignal[is] == 0) {
            Display_EntrySLValues(ir, is, sSymbol, 0,0,0);
         }
      }
      
      //---- write the number of the last valid signals
      iDigits = PairDigits[is];
      //---- long ================================================
      if (SignalAllTFs_Long == true) {
         nTradeSignals[is] = nLastTradeSignals[is] + 1;
         if (nTradeSignals[is] == 1) {
            sSignal = "firstNumber";
            dColor = colorPlusSignal;
            sNSignals = "[" + nTradeSignals[is] + "]";
            SetLabelObject(sName, sNSignals, dColor, xx, yRow[ir]);                  

            //-- alert ........................................
            if (SignalSended[is] == false) {               
               //-- long entry               
               sPrice = DoubleToStr(dLongValueEntry, iDigits);
               //-- long SL               
               sInitialSL = DoubleToStr(dLongValueSL,iDigits); // = dLowsAvg;
               SendAlerts(iOrderType1, sSymbol, iTimeFrame[col], sTimeFrame[col], sPrice, sInitialSL, is, col, ir);
               SignalSended[is] = true;
            }
         }
         else {
            sSignal = "newNumber";
            dColor = colorPlusIndi;
            sNSignals = nTradeSignals[is];                  
            SetLabelObject(sName, sNSignals, dColor, xx, yRow[ir]);
         }
      }
      else 

      //---- short ============================================
      if (SignalAllTFs_Short == true) {
         nTradeSignals[is] = nLastTradeSignals[is] + 1;
         if (nTradeSignals[is] == 1) {
            sSignal = "firstNumber";
            dColor = colorMinusSignal;
            sNSignals = "[" + nTradeSignals[is] + "]";
            SetLabelObject(sName, sNSignals, dColor, xx, yRow[ir]);
                  
            //-- alert ........................................
            if (SignalSended[is] == false) {
               //-- short entry               
               sPrice = DoubleToStr(dShortValueEntry, iDigits);
               //-- short SL               
               sInitialSL = DoubleToStr(dShortValueSL,iDigits); // = dHighsAvg;
               SendAlerts(iOrderType1, sSymbol, iTimeFrame[col], sTimeFrame[col], sPrice, sInitialSL, is, col,ir);
               SignalSended[is] = true;
            }
         }
         else {
            sSignal = "newNumber";
            dColor = colorMinusIndi;
            sNSignals = nTradeSignals[is];                  
            SetLabelObject(sName, sNSignals, dColor, xx, yRow[ir]);
         }
      }
      else
      {
         nTradeSignals[is] = 0;
         sSignal = "neutral";
      }
         
      //=======================================================
      //---- neutral signal            
      if (sSignal == "neutral") {
         DeleteObject(sName);
            
         //-- signal column is positiv, all other signals are positiv
         bool NeutralAllTFs_Long = (iOrderType1 > 1);
         for (k = col+1; k <= NumberTimeFrames; k++)
            NeutralAllTFs_Long = NeutralAllTFs_Long && (mySystemSignal[is][k][1] == 4);
                  
         bool NeutralAllTFs_Short = (iOrderType1 < -1);
         for (k = col+1; k <= NumberTimeFrames; k++)
            NeutralAllTFs_Short = NeutralAllTFs_Short && (mySystemSignal[is][k][1] == -4);

         if (NeutralAllTFs_Long == true)  {iArrow = 200; dColor = colorPlusIndi;  iHeight = 11;}
         else
         if (NeutralAllTFs_Short == true) {iArrow = 201; dColor = colorMinusIndi; iHeight = 11;}
         else                             {iArrow = 159; dColor = colorTitle;     iHeight = 2;}
               
         SetArrowObject(sName, iArrow, iHeight, dColor, xx, yRow[ir]);
      }
   }
   return;
}